Subject: Re: linux-next: build failure after merge of the rdma tree

From: Jason Gunthorpe <[email-masked]>
Date: Tue, 9 Jul 2019 12:46:34 +0000

On Tue, Jul 09, 2019 at 04:18:00AM -0300, Leon Romanovsky wrote:
> On Tue, Jul 09, 2019 at 10:04:16AM +0300, Mark Zhang wrote:
> > Hi Stephen,
> 
> Stephen,
> 
> For some reason, I wasn't in initial email report, can you please check why?
> 
> I need to be aware of any issues related to patches with my name on it
> for tracking and improving internal submission flows/checks.
> 
> >
> > Can you please try the patch below, thank you.
> 
> Jason, Doug,
> 
> Can you please take this patch?

It isn't quite enough to make the header compile stand alone, I'm
adding this instead.

>From 37c1e072276b03b080eb24ff24c39080aeaf49ef Mon Sep 17 00:00:00 2001
From: Jason Gunthorpe <[email-masked]>
Date: Tue, 9 Jul 2019 09:44:47 -0300
Subject: [PATCH] RDMA/counters: Make rdma_counter.h compile stand alone

5.4-rc1 will have new compile time debugging to test that headers can be
compiled stand alone. Many rdma headers are already broken and excluded
from the mechanism, however to avoid compile failures during the merge
window fix enough so that the newly added header compiles clean.

Fixes: 413d3347503b ("RDMA/counter: Add set/clear per-port auto mode support")
Reported-by: Stephen Rothwell <[email-masked]>
Signed-off-by: Jason Gunthorpe <[email-masked]>
Signed-off-by: Mark Zhang <[email-masked]>
---
 include/rdma/rdma_counter.h | 2 +-
 include/rdma/restrack.h     | 5 +++--
 2 files changed, 4 insertions(+), 3 deletions(-)

diff --git a/include/rdma/rdma_counter.h b/include/rdma/rdma_counter.h
index 68827700ba957e..eb99856e8b3078 100644
--- a/include/rdma/rdma_counter.h
+++ b/include/rdma/rdma_counter.h
@@ -9,10 +9,10 @@
 #include <linux/mutex.h>
 #include <linux/pid_namespace.h>
 
-#include <rdma/ib_verbs.h>
 #include <rdma/restrack.h>
 #include <rdma/rdma_netlink.h>
 
+struct ib_device;
 struct ib_qp;
 
 struct auto_mode_param {
diff --git a/include/rdma/restrack.h b/include/rdma/restrack.h
index 4041a4d96524b4..b0fc6b26bdf531 100644
--- a/include/rdma/restrack.h
+++ b/include/rdma/restrack.h
@@ -14,6 +14,9 @@
 #include <uapi/rdma/rdma_netlink.h>
 #include <linux/xarray.h>
 
+struct ib_device;
+struct sk_buff;
+
 /**
  * enum rdma_restrack_type - HW objects to track
  */
@@ -52,8 +55,6 @@ enum rdma_restrack_type {
 	RDMA_RESTRACK_MAX
 };
 
-struct ib_device;
-
 /**
  * struct rdma_restrack_entry - metadata per-entry
  */
-- 
2.21.0